#ifndef OMO_PSF_H
#define OMO_PSF_H

#ifdef __cplusplus
   extern "C" {
#endif

typedef struct
{

	/* data loaded from PSF file */
	unsigned char * reserved;
	uint32_t reserved_size;
	unsigned char * compressed_program;
	uint32_t compressed_program_size;
	uint32_t crc32;
	ALLEGRO_CONFIG * tags;

	/* uncompressed program data */
	unsigned char * program;
	unsigned long program_size;

} OMO_PSF;

OMO_PSF * omo_load_psf_file(const char * fn);
void omo_destroy_psf(OMO_PSF * psfp);
const char * omo_get_psf_tag(OMO_PSF * psfp, const char * name);

#ifdef __cplusplus
	}
#endif

#endif
